import java.util.Set;

import king.Agent;


public class ExtendedAgent extends Agent {
	public String[][][] wurld;
    public int moveCount;
	
	//Internal members
	
	//Action lastAction : lastAction is automatically updated with the last action returned by your GetAction().
	//					  On your first turn, lastAction is set to Action.NULL
	//                    
	//Point facing : facing is a vector representing the direction you're facing.
	//               You start off facing down. The book states you can't ask the world your direction,
	//               so you must update it yourself when you choose to turn.
	//               TurnedLeft() and TurnedRight() are helper methods for updating your direction.
	//               up: <0,-1>, down: <0,1>, left: <-1,0>, right: <1,0>
	//
	//Point position : position is a vector representing the position of your agent. Its up to you to change it
	//                 when your agent successfully moves forward (no bump percept). MovedForward() will do this for you.
	

	public ExtendedAgent() {
		//Give your agent a unique name
		super("YuropAgent");
		 wurld = new String[5][5][5];
        moveCount = 0;
	}
	
	
	//Each run through a Wumpus Room is a series of update loops.
	//Each loop, the world first calls your agent's PercieveResult method, and gives it a set of percepts
	//based on the current tile you're on. The percepts are from the Percept Enum, and are STENCH,BREEZE,BUMP,GLITTER,SCREAM.
	//It is up to you what you do with them.
	//The world then calls GetAction(). Based on the series of percepts you've been given, you must return the most
	//appropriate Action. The Action Enum contains TURN_LEFT, TURN_RIGHT, FORWARD, SHOOT, PICK_UP, CLIMB.
	
	
	@Override
	public Action GetAction() {
		//The world is asking what your agent wants to do.
        if (moveCount ==0){
            return Action.PICK_UP;
        }
        else if (moveCount<3){
            return Action.TURN_LEFT;
        }
		else
		return Action.FORWARD;
	}

	@Override
	public void PerceiveResult(Set<Percept> percepts) {

		//The percepts set tells your agent about the tile he's currently on.
		
	}
	
}
