import java.awt.Point;
import java.util.Set;
import java.util.Stack;


import king.Agent;
import king.Agent.Action;
import king.Agent.Percept;


public class MyAI extends Agent {
	
	
	//Internal members
	
	//Action lastAction : lastAction is automatically updated with the last action returned by your GetAction().
	//					  On your first turn, lastAction is set to Action.NULL
	//                    
	//Point facing : facing is a vector representing the direction you're facing.
	//               You start off facing down. The book states you can't ask the world your direction,
	//               so you must update it yourself when you choose to turn.
	//               TurnedLeft() and TurnedRight() are helper methods for updating your direction.
	//               up: <0,-1>, down: <0,1>, left: <-1,0>, right: <1,0>
	//
	//Point position : position is a vector representing the position of your agent. Its up to you to change it
	//                 when your agent successfully moves forward (no bump percept). MovedForward() will do this for you.
	

	public MyAI() {
		//Give your agent a unique name
		super("MyAI");
	}
	
	public Set<Percept> percSet;
	
	private int rightCount = 0;

	private boolean gold = false;
	private Stack<Action> retrace = new Stack<Action>();

	private boolean dead = false;
	
	//Each run through a Wumpus Room is a series of update loops.
	//Each loop, the world first calls your agent's PercieveResult method, and gives it a set of percepts
	//based on the current tile you're on. The percepts are from the Percept Enum, and are STENCH,BREEZE,BUMP,GLITTER,SCREAM.
	//It is up to you what you do with them.
	//The world then calls GetAction(). Based on the series of percepts you've been given, you must return the most
	//appropriate Action. The Action Enum contains TURN_LEFT, TURN_RIGHT, FORWARD, SHOOT, PICK_UP, CLIMB.
	
	
	@Override
	public Action GetAction() {
		//The world is asking what your agent wants to do.
		
		if (gold==false){
			return start_state();
		} else {
			return gold_state();
		}
	}
	
	private Action start_state(){

		
		if (percSet.contains(Percept.GLITTER)){
			gold = true;
			rightCount = 2;
			return Action.PICK_UP;
		}
		
		if (percSet.contains(Percept.STENCH)){
			if (dead == false){
				dead = true;
				return Action.SHOOT;
			}
		}
		
		if (percSet.contains(Percept.BUMP)){
			retrace.pop();
			retrace.push(Action.TURN_LEFT);
			TurnedRight();
			return Action.TURN_RIGHT;
		}
		
		retrace.push(Action.FORWARD);
		return Action.FORWARD;
		
	}
	
	private Action gold_state(){
		if (retrace.isEmpty()){
			return Action.CLIMB;
		}
			
		if (rightCount > 0){
			rightCount--;
			TurnedRight();
			return Action.TURN_RIGHT;
		}
		
		Action a = retrace.pop();
		if (a == Action.TURN_LEFT){
			TurnedLeft();
		}
		
		return a;
	}
	

	@Override
	public void PerceiveResult(Set<Percept> percepts) {
		//The percepts set tells your agent about the tile he's currently on.
		percSet = percepts;
		
//		System.out.println("-------------");
//		for (Percept p : percepts){
//			System.out.print(p+" ");
//		}
//		System.out.print("\n");
//		for (Action a : retrace){
//			System.out.print(a+" ");
//		}
//		System.out.println("\n-------------");
		

		
	}
	
}
