package king;

import java.io.File;
import java.lang.reflect.Constructor;
import java.net.URL;
import java.net.URLClassLoader;

//================================================
//Majority of this Code taken from ConnectK Shell
//================================================
public class AgentFactory {
	private Class<? extends Agent> agentClass;

	public AgentFactory(File agentFile) {
		try {
			if (agentFile.getParent() == null)
				agentFile = new File(new File(".").getAbsoluteFile(),agentFile.getName());
			ClassLoader cl = URLClassLoader.newInstance(new URL[] { agentFile.getParentFile().toURI().toURL() });
			Class<?> cls;
			cls = Class.forName(agentFile.getName().split(".class")[0], true, cl);
			System.out.println("Can't Assign");
			if (Agent.class.isAssignableFrom(cls)) {
				agentClass = (Class<? extends Agent>) cls;
				Constructor<? extends Agent> c = agentClass.getConstructor();
				c.newInstance();// test that it can be instantiated
			} else {
				
				throw new IllegalArgumentException();
			}
		} catch (Exception e){
			e.printStackTrace();
		}
	}
	
	public boolean isValid(){
		return agentClass != null;
	}
	
	public Agent generateAgent(){
		try {
			return agentClass.newInstance();
		} catch (InstantiationException | IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
	}
	
	public static boolean isAgentFile(File agentFile){
		try {
			if (agentFile.getParent() == null)
				agentFile = new File(new File(".").getAbsoluteFile(),agentFile.getName());
			ClassLoader cl = URLClassLoader.newInstance(new URL[] { agentFile.getParentFile().toURI().toURL() });
			Class<?> cls;
			cls = Class.forName(agentFile.getName().split(".class")[0], true, cl);
			System.out.println("Can't Assign");
			return Agent.class.isAssignableFrom(cls);
		} catch (Exception e){
			e.printStackTrace();
			return false;
		}
	}

}
