import java.awt.Point;
import java.util.*;
import king.*;

public class TardisAgent extends Agent {
	
	
	//Internal members
	
	//Action lastAction : lastAction is automatically updated with the last action returned by your GetAction().
	//					  On your first turn, lastAction is set to Action.NULL
	//                    
	//Point facing : facing is a vector representing the direction you're facing.
	//               You start off facing down. The book states you can't ask the world your direction,
	//               so you must update it yourself when you choose to turn.
	//               TurnedLeft() and TurnedRight() are helper methods for updating your direction.
	//               up: <0,-1>, down: <0,1>, left: <-1,0>, right: <1,0>
	//
	//Point position : position is a vector representing the position of your agent. Its up to you to change it
	//                 when your agent successfully moves forward (no bump percept). MovedForward() will do this for you.
	

	public TardisAgent() {
		//Give your agent a unique name
		super("Tardis");
	}

	public Set<Percept> percSet;
	public Point pos = new Point(1,1);
	private Random rand = new Random();
	private HashMap<Point, String> kb = new HashMap<Point, String>();
	private HashMap<Point, List<Point>> visited = new HashMap<Point, List<Point>>();
	private int rightCount = rand.nextInt(4);;
	private boolean gold = false;
	private Stack<Point> retrace = new Stack<Point>();

	@Override
	public Action GetAction() {
		return gold?GoldState():StartState();
	}

	private boolean findIfSafe(HashMap<Point, String> kb, Point pos){
		String ms = "";
		Point newPos = new Point(pos.x + facing.x , pos.y + facing.y);
		
		Point[] dir = { 
			new Point(0, 1), 
			new Point(0, -1),
			new Point(1, 0),
			new Point(-1, 0)
		};
		boolean fs = true;
		boolean fb = true;
		for (Point i: dir){
			i.translate(newPos.x, newPos.y);
			if (kb.containsKey(i)){
				if (kb.get(i).charAt(8) == '~'){
					fs = false;
					fb = false;
				}
				if (kb.get(i).charAt(7) == '~'){
					fb = false;
				}
			}
			if (!fs && !fb){
				System.out.println("safe");
				return true;
			}
		}
		return false;
	}

	private Action StartState(){
		if(percSet.contains(Percept.GLITTER)){
			gold = true;
			return Action.PICK_UP;
		}

		if (percSet.contains(Percept.BUMP)){
			System.out.print("Bump, change dir");
			this.facing = new Point(-facing.y,facing.x);
			return Action.TURN_LEFT;
		}

		String ms = "";
		if (percSet.contains(Percept.STENCH)){
			ms += "STENCH ";
		} else {
			ms += "~STENCH ";
		}
		if (percSet.contains(Percept.BREEZE)){
			ms += "BREEZE";
		} else {
			ms += "~BREEZE";
		}
		if (!kb.containsKey(pos)){
			kb.put(pos, ms);
		}
		boolean isSafe = findIfSafe(kb, pos);

		if (isSafe){
			if (!visited.containsKey(pos) || !visited.get(pos).contains(facing)){
				System.out.print("safe and unvisited move forward");
				return Action.FORWARD;
			} 
			else if(--rightCount <= -1){
				System.out.print("take risk move forward");
				rightCount = rand.nextInt(4);
				return Action.FORWARD;
			}
			else {
				this.facing = new Point(facing.y,-facing.x);
				System.out.print("safe but visited change dir");
				return Action.TURN_RIGHT;
			}
		} 
		else if(--rightCount <= -1){
			System.out.print("take risk move forward");
			rightCount = rand.nextInt(4);
			return Action.FORWARD;
		}
		else {
			System.out.print("change dir");
			System.out.print(rightCount);
			this.facing = new Point(facing.y,-facing.x);
			return Action.TURN_RIGHT;
		}
	}
	
	private Action GoldState(){
		if(retrace.isEmpty() || (pos.x==1&&pos.y==1))
			return Action.CLIMB;
		if(facing.equals(retrace.peek())){
			retrace.pop();
			return Action.FORWARD;
		}
		this.facing = new Point(facing.y,-facing.x);
		return Action.TURN_RIGHT;
	}

	@Override
	public void PerceiveResult(Set<Percept> percepts) {
		// TODO Auto-generated method stub
		percSet = percepts;
		if(lastAction == Action.FORWARD && !percepts.contains(Percept.BUMP)){
			if(!gold)
				retrace.push(new Point(-facing.x,-facing.y));
			if (!visited.containsKey(pos)){
				List<Point> lst = new ArrayList<Point>();
				lst.add(facing);
				visited.put(pos, lst);
			} else {
				visited.get(pos).add(facing);
			}
			pos.translate(facing.x, facing.y);
			
		}
	}

}
