//Xiling Zhang(42825031)
//Iris Zeng(31309641)
//TeamName: NewBee
import king.Agent;
import king.logical.KnowledgeBase;

import java.awt.Point;
import java.util.Random;
import java.util.Set;
import java.util.Stack;

public class NewBeeAI extends Agent{
	// use dummyAI as base to develop
	public NewBeeAI() {
		super("NewBee");
	}
	
	public Set<Percept> percSet;
	public Point pos = new Point(1,1);
	private Random rand = new Random();
	
	private int rightCount = 0;
	private float[] rightArray = new float[4];
	
	private boolean turnsOn = false;
	private int currentTurn = 0;
	private int totalTurn = 0;
	private boolean gold = false;
	private Stack<Point> retrace = new Stack<Point>();
	
	private KnowledgeBase KB = new KnowledgeBase();
	
	@Override
	public Action GetAction() {
		return gold?GoldState():StartState();
	}
	
	private Action StartState(){
		if(percSet.contains(Percept.GLITTER)){
			gold = true;
			return Action.PICK_UP;
		}
		// update the adjacent position
		if(percSet.contains(Percept.BREEZE)) tellBreeze(pos);
		if(percSet.contains(Percept.STENCH)) tellStench(pos);
		float pm = checkMonster(new Point(pos.x+facing.x,pos.y+facing.y)), 
				pp = checkPit(new Point(pos.x+facing.x,pos.y+facing.y));
		if(pm==0 && pp==0)
		{
			return Action.FORWARD;
		}
		
		if (rightCount == 3)
		{
			rightCount = 0;
			turnsOn = true;
			totalTurn = rand.nextInt(4)-1;
		}
		
		if (turnsOn)
		{
			if(currentTurn<totalTurn) 
			{
				currentTurn++;
				this.facing = new Point(facing.y,-facing.x);
				return Action.TURN_RIGHT;
			}
			else
			{
				turnsOn = false;
				currentTurn = 0;
				return Action.FORWARD;
			}
		}
		
		if (!turnsOn) {
			rightCount++;
			rightArray[rightCount] = pm+pp;
		}
		this.facing = new Point(facing.y,-facing.x);
		return Action.TURN_RIGHT;
	}
	
	private Action GoldState(){
		if(retrace.isEmpty() || (pos.x==1&&pos.y==1))
			return Action.FORWARD;
		if(facing.equals(retrace.peek())){
			retrace.pop();
			return Action.CLIMB;
		}
		this.facing = new Point(facing.y,-facing.x);
		return Action.TURN_LEFT;
	}
	
	
	@Override
	public void PerceiveResult(Set<Percept> percepts) {
		percSet = percepts;
		if(lastAction == Action.FORWARD && !percepts.contains(Percept.BUMP)){
			if(!gold)
				retrace.push(new Point(-facing.x,-facing.y));
			pos.translate(facing.x, facing.y);
		}
	}
	
	private void tellBreeze(Point p)
	{
		KB.tell(p.x+""+p.y+"=breeze");
		System.out.println("Updated ("+p.x+", "+p.y+") breeze");
	}
	
	private void tellStench(Point p)
	{
		KB.tell(p.x+""+p.y+"=stench");
		System.out.println("Updated ("+p.x+", "+p.y+") stench");
	}
	
	private float checkMonster(Point p)
	{
		int right = (KB.ask((p.x+1)+""+p.y+"=stench", true))?1:0,
			left = (KB.ask((p.x-1)+""+p.y+"=stench", true))?1:0,
			up = (KB.ask(p.x+""+(p.y+1)+"=stench", true))?1:0,
			down = (KB.ask(p.x+""+(p.y-1)+"=stench", true))?1:0,
			sum = right+left+up+down;
		System.out.println("checked ("+p.x+", "+p.y+") stench with "+right+" "+left+" "+up+" "+down);
		if (right == 1 && left == 1 && up == 1 && down == 1) return (float) 1;
		if ((right == 1 && left == 1) || (up == 1 && down == 1)) return (float) 1;
		if ((right == 1 || left == 1) && (up == 1 || down == 1)) return (float )0.5;
		if (right+left+up+down>=1) return (float)1/sum;
		return 0;
	}
	
	private float checkPit(Point p)
	{
		int right = (KB.ask((p.x+1)+""+p.y+"=breeze", true))?1:0,
				left = (KB.ask((p.x-1)+""+p.y+"=breeze", true))?1:0,
				up = (KB.ask(p.x+""+(p.y+1)+"=breeze", true))?1:0,
				down = (KB.ask(p.x+""+(p.y-1)+"=breeze", true))?1:0,
				sum = right+left+up+down;
		System.out.println("checked ("+p.x+", "+p.y+") breeze with "+right+" "+left+" "+up+" "+down);
		if (right == 1 && left == 1 && up == 1 && down == 1) return (float) 1;
		if (right+left+up+down>=3) return (float)3/sum;
		if (right+left+up+down>=2) return (float)2/sum;
		if (right+left+up+down>=1) return (float)1/sum;
		return 0;
	}

}
