package king;

import java.awt.Point;
import java.util.Random;
import java.util.Set;


public abstract class Agent {
	
	public Action lastAction = Action.NULL;
	public Point facing = new Point(0,1);
	public Point position = new Point(1,1);
	public String name = "No Name";
	
	public enum Action{
		TURN_LEFT, TURN_RIGHT, FORWARD, SHOOT, PICK_UP, CLIMB, NULL;
	}
	
	public enum Percept {
		STENCH,BREEZE,BUMP,GLITTER,SCREAM;
	}
	
	
	public Agent(String name){
		this.name = name;
	}
	
	public abstract Action GetAction();
	
	public abstract void PerceiveResult(Set<Percept> percepts);
	
	protected void TurnedRight(){
		this.facing = new Point(facing.y,-facing.x);
	}
	
	protected void TurnedLeft(){
		this.facing = new Point(-facing.y,facing.x);
	}
	
	protected void MovedForward(){
		this.position.translate(facing.x, facing.y);
	}
}
