package king.logical;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class KnowledgeBaseCNF extends ArrayList<ClauseCNF> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7144210655217798020L;
	protected static boolean verbose = false;
	
	protected KnowledgeBaseCNF(){
		super();
	}
	
	private static Comparator<ClauseCNF> cardinalSort = new Comparator<ClauseCNF>(){

		@Override
		public int compare(ClauseCNF a, ClauseCNF b) {
			return a.size()-b.size();
		}
		
	};
	
	public boolean Resolution(String s, boolean b){
		
		ClauseCNF test = new ClauseCNF(s,!b);
		if(this.contains(test))
			return true;
		
		
		KnowledgeBaseCNF kb2 = (KnowledgeBaseCNF) this.clone();
		kb2.add(test);
		return ResolutionHelperAlpha(kb2);
		
	}
	
	private static boolean ResolutionHelperAlpha(KnowledgeBaseCNF kb){
		
		
		
		Collections.sort(kb,cardinalSort);
		if(verbose)
			System.out.println("Current Sentences: " + kb);
		for(ClauseCNF c : kb){
			KnowledgeBaseCNF kb2 = (KnowledgeBaseCNF) kb.clone();
			kb2.remove(c);
			if(verbose)
				System.out.println("Testing merges with " + c);
			if(ResolutionHelperBeta(kb2,c))
				return true;
			if(verbose)
				System.out.println("Failed branch, restoring " + c);
		}
		
		return false;
	}
	
	private static boolean ResolutionHelperBeta(KnowledgeBaseCNF kb,ClauseCNF cl){
		for(ClauseCNF c : kb){
			if(c.canMerge(cl)){
				KnowledgeBaseCNF kb2 = (KnowledgeBaseCNF) kb.clone();
				kb2.remove(c);
				
				ClauseCNF test = c.unsafeMerge(cl);
				if(verbose)
					System.out.println("Merge " + cl + " and " + c + " to form " + test);
				if(test.size()==0)
					return true;
				
				kb2.add(test);
				if(ResolutionHelperAlpha(kb2))
					return true;
			}
		}
		
		return false;
	}
	
	public boolean contains(ClauseCNF c1){
		for(ClauseCNF c : this){
			if(c.equals(c1))
				return true;
		}
		return false;
	}
	
}
