package king.logical.fol;

import java.util.HashMap;
import java.util.Map;

public class FOL_Predicate extends FOL_Object {
	
	protected Map<String,Boolean> map = new HashMap<String,Boolean>();
	
	public FOL_Predicate(String name){
		super(name);
		type = Type.PREDICATE;
	}
	
	public void add(String a, boolean val){
		map.put(a, val);
	}
	
	public void add(String a, String b, boolean val){
		map.put(a + " " + b, val);
	}
	
	public void add(String a, String b, String c, boolean val){
		map.put(a + " " + b + " " + c, val);
	}
	
	public boolean get(String a){
		Boolean ret = map.get(a);
		return (ret==null)?false:ret;
	}
	
	public boolean get(String a, String b){
		Boolean ret = map.get(a + " " + b);
		return (ret==null)?false:ret;
	}
	
	public boolean get(String a, String b, String c){
		Boolean ret = map.get(a + " " + b + " " + c);
		return (ret==null)?false:ret;
	}
	
	public void absorb(FOL_Predicate other){
		map.putAll(other.map);
	}
}
