import java.util.Set;
import java.util.ArrayList;
import java.util.List;

import king.Agent;
import king.Tile;

public class ExtendedAgent extends Agent {
	
	
	//Internal members
	
	//Action lastAction : lastAction is automatically updated with the last action returned by your GetAction().
	//					  On your first turn, lastAction is set to Action.NULL
	//                    
	//Point facing : facing is a vector representing the direction you're facing.
	//               You start off facing down. The book states you can't ask the world your direction,
	//               so you must update it yourself when you choose to turn.
	//               TurnedLeft() and TurnedRight() are helper methods for updating your direction.
	//               up: <0,-1>, down: <0,1>, left: <-1,0>, right: <1,0>
	//
	//Point position : position is a vector representing the position of your agent. Its up to you to change it
	//                 when your agent successfully moves forward (no bump percept). MovedForward() will do this for you.
	

	public ExtendedAgent() {
		//Give your agent a unique name
		//super("Your Agent Name Here");
		super("eliminater");
	}
	
	
	
	//Each run through a Wumpus Room is a series of update loops.
	//Each loop, the world first calls your agent's PercieveResult method, and gives it a set of percepts
	//based on the current tile you're on. The percepts are from the Percept Enum, and are STENCH,BREEZE,BUMP,GLITTER,SCREAM.
	//It is up to you what you do with them.
	//The world then calls GetAction(). Based on the series of percepts you've been given, you must return the most
	//appropriate Action. The Action Enum contains TURN_LEFT, TURN_RIGHT, FORWARD, SHOOT, PICK_UP, CLIMB.
	
	// list exmaple: public List<AgentFactory> factoryList = new ArrayList<AgentFactory>();
	ArrayList<ArrayList<Integer>> breath_list = new ArrayList<ArrayList<Integer>>(); // List of Pairs
	ArrayList<ArrayList<Integer>> stinch_list = new ArrayList<ArrayList<Integer>>(); // List of Pairs
	ArrayList<ArrayList<Integer>> visited_list = new ArrayList<ArrayList<Integer>>();// List of Pairs

	List<List<Integer>> board;
	Tile t;

	int width = 4;
	int height = 4;
    ArrayList<Integer> current_move = new ArrayList<Integer>();
    //add method for integer ArrayList
    int start = 0;
	int facing = 180;
	ArrayList<String> actions = new ArrayList<String>(); // List of Pairs
	boolean inprog = false;
	//Check if spot has breath
	public boolean breath(Integer x, Integer y){
		//for each item in breath check if this in it ^^^
		return true;
	}
	
	//Check if spot has stinch
	public boolean stinch(Integer x, Integer y){
		//for each item in stinch check if this in it ^^^
		return true;
	}
	
	//Check if spot visited
	public boolean visited(Integer x, Integer y){
		///see if x,y = visted_list[x][0], vistied_list[x][1]
		for (int i = 0; i<visited_list.size(); x++){
			if (visited_list.get(i).get(0) == x && visited_list.get(i).get(1) == y){
				return true;
			}
		}
		return false;
	}
	
	public boolean onBoard(Integer x, Integer y){
		if(x >= 0 && x < width && y >= 0 && y < height)
			return false;
		return true;
	}
	
	//Get all key spots
	public ArrayList<ArrayList<Integer>> getAllSpots(Integer x, Integer y){		
//		ArrayList<ArrayList<Integer>> all_pts = new ArrayList<ArrayList<Integer>>();
		ArrayList<ArrayList<Integer>> all_pts = new ArrayList<ArrayList<Integer>>();		
		
		ArrayList<Integer> temp = new ArrayList<Integer>();
		temp.add(x,y+2);
		ArrayList<Integer> temp1 = new ArrayList<Integer>();		
		temp1.add(x-1,y+1);
		ArrayList<Integer> temp2 = new ArrayList<Integer>();
		temp2.add(x,y+1);
		ArrayList<Integer> temp3 = new ArrayList<Integer>();
		temp3.add(x+1,y+1);
		ArrayList<Integer> temp4 = new ArrayList<Integer>();
		temp4.add(x-2,y);
		ArrayList<Integer> temp5 = new ArrayList<Integer>();
		temp5.add(x-1,y);
		ArrayList<Integer> temp6 = new ArrayList<Integer>();
		temp6.add(x+1,y);
		ArrayList<Integer> temp7 = new ArrayList<Integer>();
		temp7.add(x+2,y);
		ArrayList<Integer> temp8 = new ArrayList<Integer>();
		temp8.add(x-1,y-1);
		ArrayList<Integer> temp9 = new ArrayList<Integer>();
		temp9.add(x,y-1);
		ArrayList<Integer> temp10 = new ArrayList<Integer>();
		temp10.add(x+1,y-1);
		ArrayList<Integer> temp11 = new ArrayList<Integer>();
		temp11.add(x,y-2);
		
		all_pts.add(temp);
		all_pts.add(temp1);
		all_pts.add(temp2);
		all_pts.add(temp3);
		all_pts.add(temp4);
		all_pts.add(temp5);
		all_pts.add(temp6);
		all_pts.add(temp7);
		all_pts.add(temp8);
		all_pts.add(temp9);
		all_pts.add(temp10);
		all_pts.add(temp11);

		return all_pts;
	}
	
	//Checks if spot is safe
	public boolean safe(Integer x, Integer y){
		return true;
	}
	
	
	
	//Checks if right is safe
	public boolean issafe(Integer x, Integer y){
		/* (x+1, y_+1) (x+2, y) (x+1,y-1)
		 * check if 3 points are in any of 3 lists, if it is return false
		 * otherwise, true
		 */
		int a = 0;
		int b = 0;
		int c = 0;
		int d = 0;
		for(int i = 0; i < breath_list.size(); i++)
		{
			if(breath_list.get(i).get(0) == x+1 && breath_list.get(i).get(1) == y)
			{
				a++;
			}
			if(breath_list.get(i).get(0) == x-1 && breath_list.get(i).get(1) == y)
			{
				b++;
			}
			if(breath_list.get(i).get(0) == x && breath_list.get(i).get(1) == y-1)
			{
				c++;
			}
			if(breath_list.get(i).get(0) == x && breath_list.get(i).get(1) == y+1)
			{
				d++;
			}
		}

		for(int j = 0; j < stinch_list.size(); j++)
		{
			if(stinch_list.get(j).get(0) == x+1 && stinch_list.get(j).get(1) == y)
			{
				a++;
			}
			if(stinch_list.get(j).get(0) == x-1 && stinch_list.get(j).get(1) == y)
			{
				b++;
			}
			if(stinch_list.get(j).get(0) == x && stinch_list.get(j).get(1) == y-1)
			{
				c++;
			}
			if(stinch_list.get(j).get(0) == x && stinch_list.get(j).get(1) == y+1)
			{
				d++;
			}		
		}
		for(int k = 0; k < visited_list.size(); k++)
		{
			if(visited_list.get(k).get(0) == x+1 && visited_list.get(k).get(1) == y)
			{
				a++;
			}
			if(visited_list.get(k).get(0) == x-1 && visited_list.get(k).get(1) == y)
			{
				b++;
			}
			if(visited_list.get(k).get(0) == x && visited_list.get(k).get(1) == y-1)
			{
				c++;
			}
			if(visited_list.get(k).get(0) == x && visited_list.get(k).get(1) == y+1)
			{
				d++;
			}			
		}
		if(a == 1 || b == 1 || c == 1 || d == 1)
			return false;
		return true;
	}
	
	
	public boolean right_safe(Integer x, Integer y){
		return issafe(x+1, y);
	}
	
	//Checks if left is safe
	public boolean left_safe(Integer x, Integer y){
		return issafe(x-1, y);
	}
	
	//Checks if bk is safe
	public boolean backward_safe(Integer x, Integer y){
		return issafe(x, y+1);
	}
	
	//Checks if forward is safe
	public boolean forward_safe(Integer x, Integer y){
		return issafe(x, y-1);
	}
	
	//turn right = 1 turn left = 0 forward = 2 
	public void make_moves(int desired_angle)
	{
		int diff = facing - desired_angle;
		if (diff < 0)
		{
			while (diff < 360)
				diff += 360;
			for(int i = 0; i < diff/90; i++){
				actions.add("1");//turn right 1 turn left 0
			}
		}
		if(diff > 0)
		{
			while (diff > 360)
				diff -= 360;
			for(int i = 0; i < diff/90; i++){
				actions.add("0");//turn right 1 turn left 0
			}
		}
		actions.add("2");				
	}
	

	@Override
	public Action GetAction() {
		if(start == 0)
		{
			facing = 180;
			t = new Tile();
			current_move.add(0);
			current_move.add(0);
			////////////////////////////////////////////
			start = 1;
			//start++;
		}
		
		if(t.breeze)
		{
			breath_list.add(current_move);
		}
		if(t.stench)
		{
			stinch_list.add(current_move);
		}
	
		
		visited_list.add(current_move);
		
		
		//The world is asking what your agent wants to do.
		//call finish_up
		/*
		 * check if there is anything fucked up where u are at, and add to fucky list
		
		breath_list.add(toto); // List of Pairs
		List<List<Integer>> stinch_list; // List of Pairs
		
		*/
		
	
		/*if(start == 1)
		{
			return Action.FORWARD;
		}
		if(start == 2)
		{
			return Action.TURN_LEFT;
		}
		if(start == 3)
		{
			return Action.TURN_LEFT;
		}
		*/
		//return Action.TURN_RIGHT;
		/*if(start)
		{
			current_move.add(0);
			current_move.add(0);
			start = !start;
		}
		*/
		if(forward_safe(current_move.get(0), current_move.get(1))){
			
			//int x = current_move.get(0);
			//int y = current_move.get(1);
			//current_move.remove(x);
			//current_move.remove(y);//Y = y+1
			//current_move.add(x);
			//current_move.add(y+1);
			
			make_moves(180);
		}
		if(backward_safe(current_move.get(0), current_move.get(1))){
			/*int x = current_move.get(0);
			int y = current_move.get(1);
			current_move.remove(x);
			current_move.remove(y);//Y = y-1
			current_move.add(x);
			current_move.add(y-1);*/
			make_moves(0);
		}
		if(right_safe(current_move.get(0), current_move.get(1))){
			/*int x = current_move.get(0);
			int y = current_move.get(1);
			current_move.remove(x);
			current_move.remove(y);//x=x+1
			current_move.add(x+1);
			current_move.add(y);*/
			make_moves(90);
		}
		if(left_safe(current_move.get(0), current_move.get(1))){
			/*int x = current_move.get(0);
			int y = current_move.get(1);
			current_move.remove(x);
			current_move.remove(y);//x = x-1
			current_move.add(x-1);
			current_move.add(y);*/
			make_moves(270);
		}
		if(actions.size() != 0)
		{
			String the_move = actions.get(0);
			actions.remove(0);
			if(the_move == "0")
			{
				return Action.TURN_LEFT;
			}
			if(the_move == "1")
			{
				return Action.TURN_RIGHT;
				
			}
			if(the_move == "2")
			{
				int x = current_move.get(0);
				int y = current_move.get(1);
				if(facing == 0 || facing == 360){
					current_move.remove(0);
					current_move.remove(1);//Y = y+1
					current_move.add(x);
					current_move.add(y-1);
				}
				if(facing == 90){
					current_move.remove(0);
					current_move.remove(1);//Y = y+1
					current_move.add(x+1);
					current_move.add(y);
				}
				if(facing == 180){
					current_move.remove(0);
					current_move.remove(1);//Y = y+1
					current_move.add(x);
					current_move.add(y+1);
				}
				if(facing == 270){
					current_move.remove(0);
					current_move.remove(1);//Y = y+1
					current_move.add(x-1);
					current_move.add(y);
				}
				return Action.FORWARD;
			}
		}
	return Action.FORWARD;	
	}

	@Override
	public void PerceiveResult(Set<Percept> percepts) {
		//The percepts set tells your agent about the tile he's currently on.
		/*if (percepts.contains(Percept.BREEZE)){
			t.explored = true;
			t.breeze = true;
		}
		if (percepts.contains(Percept.STENCH)){
			t.explored = true;
			t.stench = true;
		}
		if (percepts.contains(Percept.BUMP)){
			t.explored = true;
			t.breeze = true;
		}
		if (percepts.contains(Percept.GLITTER)){
			t.explored = true;
			t.gold = true;
		}
//		if (percepts.contains(Percept.SCREAM)){
//			t.explored = true;
//			t.breeze = true;
//		}
//		public boolean pit = false;
//		public boolean wumpus = false;
//		public boolean deadwumpus = false;
//		public boolean explored = false;
//		public boolean gold = false;
//		public boolean breeze = false;
//		public boolean stench = false;
		//STENCH,BREEZE,BUMP,GLITTER,SCREAM;
		
	
	*/

	}
}